#ifndef __EDP_KIT_H__
#define __EDP_KIT_H__

#ifdef EDPKIT_EXPORTS
	#define EDPKIT_DLL __declspec(dllexport)
#else
	#define EDPKIT_DLL
#endif

#include "types.h"
#include "Common.h"
#include "cJSON.h"
#include "time.h"
/*
 * history
 * 2015-06-01 v1.0.1 wululu fix bug: malloc for string, MUST memset to 0
 * 2015-07-10 v1.1.0 wusongwei add UnpackCmdReq() and PacketCmdResp()
 * 2015-07-13 v1.1.1 wululu ӷװjsonĽӿ, windows汾dll
 * 2015-07-13 v1.1.2 wululu ֧doublestring͵Ĵͽ
 * 2015-07-15 v1.1.3 wusongwei SAVEACKӦ
 * 2015-07-20 v1.1.4 wusongwei /޸SAVEDATAϢĴ/
 */

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------*/
#define MOSQ_MSB(A)         (uint8)((A & 0xFF00) >> 8)
#define MOSQ_LSB(A)         (uint8)(A & 0x00FF)
#define BUFFER_SIZE         (0x100) 
#define PROTOCOL_NAME       "EDP"
#define PROTOCOL_VERSION    1
/*---------------------------------------------------------------------*/
#define ERR_UNPACK_CONNRESP_REMAIN              -1000
#define ERR_UNPACK_CONNRESP_FLAG                -1001
#define ERR_UNPACK_CONNRESP_RTN                 -1002
#define ERR_UNPACK_PUSHD_REMAIN                 -1010
#define ERR_UNPACK_PUSHD_DEVID                  -1011
#define ERR_UNPACK_PUSHD_DATA                   -1012
#define ERR_UNPACK_SAVED_REMAIN                 -1020
#define ERR_UNPACK_SAVED_TANSFLAG               -1021
#define ERR_UNPACK_SAVED_DEVID                  -1022
#define ERR_UNPACK_SAVED_DATAFLAG               -1023
#define ERR_UNPACK_SAVED_JSON                   -1024
#define ERR_UNPACK_SAVED_PARSEJSON              -1025
#define ERR_UNPACK_SAVED_BIN_DESC               -1026
#define ERR_UNPACK_SAVED_PARSEDESC              -1027
#define ERR_UNPACK_SAVED_BINLEN                 -1028
#define ERR_UNPACK_SAVED_BINDATA                -1029
#define ERR_UNPACK_PING_REMAIN                  -1030
#define ERR_UNPACK_CMDREQ                       -1031
#define ERR_UNPACK_ENCRYPT_RESP                 -1032
#define ERR_UNPACK_SAVEDATA_ACK                 -1033

/*----------------------------Ϣ---------------------------------------*/
/*  */
#define CONNREQ             0x10
/* Ӧ */
#define CONNRESP            0x20
/* ת(͸) */
#define PUSHDATA            0x30
/* 洢(ת) */
#define SAVEDATA            0x80
/* 洢ȷ */
#define SAVEACK             0x90
/*  */
#define CMDREQ              0xA0
/* Ӧ */
#define CMDRESP             0xB0
/*  */
#define PINGREQ             0xC0
/* Ӧ */
#define PINGRESP            0xD0
/*  */
#define ENCRYPTREQ          0xE0
/* Ӧ */
#define ENCRYPTRESP         0xF0

#ifndef NULL
#define NULL (void*)0
#endif

/* SAVEDATAϢֵ֧ĸʽ */
typedef enum {
    kTypeFullJson = 0x01,
    kTypeBin = 0x02,
    kTypeSimpleJsonWithoutTime = 0x03,
    kTypeSimpleJsonWithTime = 0x04,
    kTypeString = 0x05
}SaveDataType;

/*-------------buffer, buffer, EDPṹ-------------------------*/
EDPKIT_DLL 
typedef struct Buffer
{
    uint8*  _data;          /* buffer */
    uint32  _write_pos;     /* bufferдλ */
    uint32  _read_pos;      /* bufferȡλ */
    uint32  _capacity;      /* buffer */
}Buffer, SendBuffer, RecvBuffer, EdpPacket;
/*-----------------------------BufferĽӿ------------------------------*/
/* 
 * :  NewBuffer
 * :    Buffer
 * ˵:    һ, NewBufferDeleteBufferӦóɶԳ
 * :    
 * ֵ:   (Buffer*)
 *          ֵǿ Bufferɹ, Bufferָ
 *          ֵΪ Bufferʧ, ڴ治
 */
EDPKIT_DLL Buffer* NewBuffer(void);
/* 
 * :  DeleteBuffer
 * :    Buffer
 * ˵:    һ, NewBufferDeleteBufferӦóɶԳ
 * :    buf     һBufferָָ
 * ֵ:  
 */
EDPKIT_DLL void DeleteBuffer(Buffer** buf);
/* 
 * :  CheckCapacity
 * :    BufferǷܹд볤Ϊlenֽ, 
 *          Buffer, ԶɱչBuffer(ӰBuffer)
 * :    buf     ҪдBufferָ
 *          len     дĳ
 * ֵ:   (int32)
 *          <0      ʧ, ڴ治
 *          =0      ɹ
 */
EDPKIT_DLL int32 CheckCapacity(Buffer* buf, uint32 len);

/*------------------------ȡEDPݵĽӿ-------------------------------*/
/* 
 * :  ReadByte
 * :    EDPЭ, Buffer()жȡһֽ
 * :    pkg     EDP
 *          val     (һֽ)
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 ReadByte(EdpPacket* pkg, uint8* val);
/* 
 * :  ReadBytes
 * :    EDPЭ, Buffer()жȡcountֽ
 * ˵:    valmalloc, ҪͻԼfree 
 * :    pkg     EDP
 *          val     (countֽ)
 *          count   ֽ
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 ReadBytes(EdpPacket* pkg, uint8** val, uint32 count);
/* 
 * :  ReadUint16
 * :    EDPЭ, Buffer()жȡuint16ֵ
 * :    pkg     EDP
 *          val     uint16ֵ
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 ReadUint16(EdpPacket* pkg, uint16* val);
/* 
 * :  ReadUint32
 * :    EDPЭ, Buffer()жȡuint32ֵ
 * :    pkg     EDP
 *          val     uint32ֵ
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 ReadUint32(EdpPacket* pkg, uint32* val);
/* 
 * :  ReadStr
 * :    EDPЭ, Buffer()жȡַ, \0β
 * :    pkg     EDP
 *          val     ַ
 * ˵:    valmalloc, ҪͻԼfree 
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 ReadStr(EdpPacket* pkg, char** val);
/* 
 * :  ReadRemainlen
 * :    EDPЭ, Buffer()remainlen
 * ˵:    remainlenEDPЭеĸ, һEDPĳ
 * :    pkg     EDP
 *          len_val remainlen
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 ReadRemainlen(EdpPacket* pkg, uint32* len_val);

/*------------------------дEDPĽӿ-------------------------------*/
/*
 * ˵:    Ŀǰ֧һдڶȡ, , ֻж_read_posΪ0İܱд
 */
/* 
 * :  WriteByte
 * :    EDPЭ, һֽдBuffer()
 * :    pkg     EDP
 *          byte    (һֽ)
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 WriteByte(Buffer* buf, uint8 byte);
/* 
 * :  WriteBytes
 * :    EDPЭ, countֽдBuffer()
 * :    pkg     EDP
 *          bytes   
 *          count   ֽ
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 WriteBytes(Buffer* buf, const void* bytes, uint32 count);
/* 
 * :  WriteUint16
 * :    EDPЭ, uint16дBuffer()
 * :    pkg     EDP
 *          val     uint16
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 WriteUint16(Buffer* buf, uint16 val);
/* 
 * :  WriteUint32
 * :    EDPЭ, uint32дBuffer()
 * :    pkg     EDP
 *          val     uint32
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 WriteUint32(Buffer* buf, uint32 val);
/* 
 * :  WriteStr
 * :    EDPЭ, ַдBuffer()
 * :    pkg     EDP
 *          val     ַ
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 WriteStr(Buffer* buf, const char *str);
/* 
 * :  WriteRemainlen 
 * :    EDPЭ, remainlenдBuffer()
 * ˵:    remainlenEDPЭеĸ, һEDPĳ
 * :    pkg     EDP
 *          len_val remainlen
 * ֵ:   (int32)
 *          <0      ʧ, pkg
 *          =0      ɹ
 */
EDPKIT_DLL int32 WriteRemainlen(Buffer* buf, uint32 len_val);
/* 
 * :  IsPkgComplete 
 * :    жϽյBuffer, ǷΪһEDP
 * :    buf     յBuffer()
 * ֵ:   (int32)
 *          =0      ݻδ, Ҫ
 *          >0      ɹ
 *          <0      ݴ, EDPЭ
 */
EDPKIT_DLL int32 IsPkgComplete(RecvBuffer* buf);

/*-----------------------------ͻ˲Ľӿ------------------------------*/
/* 
 * :  GetEdpPacket 
 * :    յĶ, ֽһһEDP
 * ˵:    صEDPʹú, Ҫɾ
 * غ:EdpPacketType, Unpack***ຯ
 * :    buf         ջ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭ
 */
EDPKIT_DLL EdpPacket* GetEdpPacket(RecvBuffer* buf);

/* 
 * :  EdpPacketType 
 * :    ȡһEDPϢ, ͻϢͬĴ
 * غ:Unpack***ຯ
 * :    pkg         EDPЭ
 * ֵ:   (uint8) 
 *          ֵ          Ϣ(ϸμhϢͶ)
 */
/* :
 * ...
 * int8 mtype = EdpPacketType(pkg);
 * switch(mtype)
 * {
 *  case CONNRESP:
 *      UnpackConnectResp(pkg);
 *      break;
 *  case PUSHDATA:
 *      UnpackPushdata(pkg, src_devid, data, data_len);
 *      break;
 *  case SAVEDATA:
 *      UnpackSavedata(pkg, src_devid, flag, data);
 *      break;
 *  case PINGRESP:
 *      UnpackPingResp(pkg); 
 *      break;
 *  ...
 * }
 */
EDPKIT_DLL uint8 EdpPacketType(EdpPacket* pkg);

/* 
 * :  PacketConnect1 
 * :     豸豸ƵEDPЭ, 豸Ƶ(¼֤ʽ1)
 * ˵:    صEDP͸豸ƺ, Ҫͻɾð
 *          豸ƻظӦ豸
 * غ:UnpackConnectResp
 * :    devid       豸ID, 豸ʱƽ̨صID
 *          auth_key    ȨϢ(api-key), ƽ̨ĿԲ豸api-keyַ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketConnect1(const char* devid, const char* auth_key);

/* 
 * :  PacketConnect2 
 * :     豸豸ƵEDPЭ, 豸Ƶ(¼֤ʽ2)
 * ˵:    صEDP͸豸ƺ, Ҫͻɾð
 *          豸ƻظӦ豸
 * غ:UnpackConnectResp
 * :    userid      ûID, ƽ̨ע˺ʱƽ̨صûID
 *          auth_info   ȨϢ, ƽ̨豸ʱд豸auth_info
 *                      (jsonַ), Ҫ߱Ψһ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketConnect2(const char* userid, const char* auth_info);

/* 
 * :  UnpackConnectResp
 * :     豸Ƶ豸EDPЭ, Ӧ
 * ˵:    豸Ʒ, ͨGetEdpPacketEdpPacketTypeжϳӦ, 
 *          ӦEDPΪ, ɸúн
 * غ:PacketConnect1, PacketConnect2, GetEdpPacket, EdpPacketType
 * :    pkg         EDP, Ӧ
 * ֵ:   (int32) 
 *          =0          ӳɹ
 *          >0          ʧ, ʧԭ<OneNet뷽ӿ.docx>
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackConnectResp(EdpPacket* pkg);

/* 
 * :  PacketPushdata
 * :     豸豸ƵEDPЭ, 豸豸֮ת
 * ˵:    صEDP͸豸ƺ, Ҫɾ
 * غ:UnpackPushdata
 * :    dst_devid   Ŀ豸ID
 *          data        
 *          data_len    ݳ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketPushdata(const char* dst_devid, 
        const char* data, uint32 data_len);

/* 
 * :  UnpackPushdata
 * :     豸Ƶ豸EDPЭ, 豸豸֮ת
 * ˵:    豸Ʒ, ͨGetEdpPacketEdpPacketTypeжϳpushdata, 
 *          ӦEDPΪ, ɸúн 
 *          صԴ豸ID(src_devid)(data)Ҫͻͷ
 * غ:PacketPushdata, GetEdpPacket, EdpPacketType
 * :    pkg         EDP, pushdata
 *          src_devid   Դ豸ID
 *          data        
 *          data_len    ݳ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackPushdata(EdpPacket* pkg, char** src_devid, 
        char** data, uint32* data_len);

/* 
 * :  PacketSavedataJson
 * :     豸豸ƵEDPЭ, 洢(jsonʽ)
 * ˵:    صEDP͸豸ƺ, Ҫɾ
 * غ:UnpackSavedata, UnpackSavedataJson
 * :    dst_devid   Ŀ豸ID
 *          json_obj    json
 *          type        json         
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EdpPacket* PacketSavedataJson(const char* dst_devid, cJSON* json_obj, int type);

/* 
 * :  PacketSavedataInt
 * :     豸豸ƵEDPЭ, 洢(jsonʽ)
 * ˵:    úݵΪint͵
 *          ѲװEDPЭ涨cJSON,
 *          type;ʹJSONʽʽ˵ĵ豸ն˽Э2-EDP.docx
 * غ:UnPacketSavedataInt
 * :    type        õJSONͣѡΪkTypeFullJson, 
 *                      kTypeSimpleJsonWithoutTime, kTypeSimpleJsonWithTime
 *          dst_devid   Ŀ豸ID
 *          ds_id       ID
 *          value       intݵ
 *          at          Ϊ0ϵͳǰʱ䣬øʱ䡣
 *                      typeѡΪkTypeSimpleJsonWithoutTime͵JSONʽʱ䣬
 *                      ͳһϵͳʱ䣬ֵ
 *          token       typeΪkTypeFullJsonʱEDPЭװtokenֶΣ
 *                      Ϊʱԡ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketSavedataInt(SaveDataType type, const char* dst_devid, 
					const char* ds_id, int value, 
					time_t at, const char* token);

/* 
 * :  PacketSavedataDouble
 * :     豸豸ƵEDPЭ, 洢(jsonʽ)
 * ˵:    úݵΪdouble͵
 *          ѲװEDPЭ涨cJSON,
 *          type;ʹJSONʽʽ˵ĵ豸ն˽Э2-EDP.docx
 * غ:UnPacketSavedataDouble
 * :    type        õJSONͣѡΪkTypeFullJson, 
 *                      kTypeSimpleJsonWithoutTime, kTypeSimpleJsonWithTime
 *          dst_devid   Ŀ豸ID
 *          ds_id       ID
 *          value       doubleݵ
 *          at          Ϊ0ϵͳǰʱ䣬øʱ䡣
 *                      typeѡΪkTypeSimpleJsonWithoutTime͵JSONʽʱ䣬
 *                      ͳһϵͳʱ䣬ֵ
 *          token       typeΪkTypeFullJsonʱEDPЭװtokenֶΣ
 *                      Ϊʱԡ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketSavedataDouble(SaveDataType type, const char* dst_devid, 
				const char* ds_id, double value, 
				time_t at, const char* token);

/* 
 * :  PacketSavedataString
 * :     豸豸ƵEDPЭ, 洢(jsonʽ)
 * ˵:    úݵΪchar*͵
 *          ѲװEDPЭ涨cJSON,
 *          type;ʹJSONʽʽ˵ĵ豸ն˽Э2-EDP.docx
 * غ:UnPacketSavedataString
 * :    type        õJSONͣѡΪkTypeFullJson, 
 *                      kTypeSimpleJsonWithoutTime, kTypeSimpleJsonWithTime
 *          dst_devid   Ŀ豸ID
 *          ds_id       ID
 *          value       char*ݵ
 *          at          Ϊ0ϵͳǰʱ䣬øʱ䡣
 *                      typeѡΪkTypeSimpleJsonWithoutTime͵JSONʽʱ䣬
 *                      ͳһϵͳʱ䣬ֵ
 *          token       typeΪkTypeFullJsonʱEDPЭװtokenֶΣ
 *                      Ϊʱԡ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketSavedataString(SaveDataType type, const char* dst_devid, 
				const char* ds_id, const char* value, 
				time_t at, const char* token);

/* 
 * :  UnpackSavedataInt
 * :     豸Ƶ豸EDPЭ, 洢
 * ˵:    豸Ʒ,еIDֵ
 *
 * غ:PacketSavedataInt
 *          
 * :    type        õJSONͣѡΪkTypeFullJson, 
 *                      kTypeSimpleJsonWithoutTime, kTypeSimpleJsonWithTime
 *          pkg         EDP, savedata
 *          ds_id       ȡIDʹͷ
 *          value       Ӧֵ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, -1 typeͲϷֵhļĴ
 */
EDPKIT_DLL int32 UnpackSavedataInt(SaveDataType type, EdpPacket* pkg,
				     char** ds_id, int* value);

/* 
 * :  UnpackSavedataDouble
 * :     豸Ƶ豸EDPЭ, 洢
 * ˵:    豸Ʒ,еIDֵ
 *
 * غ:PacketSavedataDouble
 *          
 * :    type        õJSONͣѡΪkTypeFullJson, 
 *                      kTypeSimpleJsonWithoutTime, kTypeSimpleJsonWithTime
 *          pkg         EDP, savedata
 *          ds_id       ȡIDʹͷ
 *          value       Ӧֵ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, -1 typeͲϷֵhļĴ
 */
EDPKIT_DLL int32 UnpackSavedataDouble(SaveDataType type, EdpPacket* pkg,
					char** ds_id, double* value);

/* 
 * :  UnpackSavedataString
 * :     豸Ƶ豸EDPЭ, 洢
 * ˵:    豸Ʒ,еIDֵ
 *
 * غ:PacketSavedataString
 *          
 * :    type        õJSONͣѡΪkTypeFullJson, 
 *                      kTypeSimpleJsonWithoutTime, kTypeSimpleJsonWithTime
 *          pkg         EDP, savedata
 *          ds_id       ȡIDʹҪͷ
 *          value       ӦֵʹҪͷ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, -1 typeͲϷֵhļĴ
 */
EDPKIT_DLL int32 UnpackSavedataString(SaveDataType type, EdpPacket* pkg,
					char** ds_id, char** value);


/* 
 * :  UnpackSavedataAck
 * :     豸Ƶ豸EDPЭ, תϢӦ
 * ˵:    תϢtokenʱƽ̨ӦһSAVE_ACKϢ
 *          洢Ϣȷϡ
 * غ: PacketSavedataDoubleWithToken PacketSavedataStringWithToken
 * :    pkg         EDP, Ӧ
 *          json_ack    ȡӦjsonַʹҪͷ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackSavedataAck(EdpPacket* pkg, char** json_ack);

/* 
 * :  PacketSavedataSimpleString
 * :     豸豸ƵEDPЭ, 洢(Էֺŷָļַʽ)
 * ˵:    صEDP͸豸ƺ, Ҫɾ
 * غ:UnpackSavedataSimpleString
 * :    dst_devid   Ŀ豸ID
 *          input       Էֺŷָļַʽ
 *                      豸ն˽Э2-EDP.docx
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketSavedataSimpleString(const char* dst_devid, const char* input);

/* 
 * :  UnpackSavedataSimpleString
 * :     豸Ƶ豸EDPЭ, 洢
 * ˵:    豸Ʒ, ͨGetEdpPacketEdpPacketTypeжϳsavedata,
 *          ӦEDPΪ, ɸúн,
 *          ȡԴ˷ԷֺΪַָ
 * غ: PacketSavedataSimpleString
 *          
 * :    pkg         EDP, savedata
 *          output      洢ַ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackSavedataSimpleString(EdpPacket* pkg, char** output);

/* 
 * :  PacketSavedataBin
 * :     豸豸ƵEDPЭ, 洢(binʽ)
 * ˵:    صEDP͸豸ƺ, Ҫɾ
 * غ:UnpackSavedata, UnpackSavedataBin
 * :    dst_devid   Ŀ豸ID
 *          desc_obj     jsonʽ
 *          bin_data    
 *          bin_len     ݳ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EdpPacket* PacketSavedataBin(const char* dst_devid, 
        cJSON* desc_obj, const uint8* bin_data, uint32 bin_len);
/* 
 * :  PacketSavedataBinStr
 * :     豸豸ƵEDPЭ, 洢(binʽ)
 * ˵:    صEDP͸豸ƺ, Ҫɾ
 * غ:UnpackSavedata, UnpackSavedataBin
 * :    dst_devid   Ŀ豸ID
 *          desc_obj     ַʽ
 *          bin_data    
 *          bin_len     ݳ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketSavedataBinStr(const char* dst_devid, 
        const char* desc_str, const uint8* bin_data, uint32 bin_len);

/* 
 * :  UnpackSavedata
 * :     豸Ƶ豸EDPЭ, 洢
 * ˵:    豸Ʒ, ͨGetEdpPacketEdpPacketTypeжϳsavedata,
 *          ӦEDPΪ, ɸúн 
 *          Ȼٸjsonbinıʶ(jb_flag), ӦĽ
 *          صԴ豸ID(src_devid)Ҫͻͷ
 * غ:PacketSavedataJson, PacketSavedataBin, GetEdpPacket, 
 *          UnpackSavedataJson, UnpackSavedataBin
 * :    pkg         EDP, savedata
 *          src_devid   Դ豸ID
 *          jb_flag     json or bin, 1: json, 2: 
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackSavedata(EdpPacket* pkg, char** src_devid, uint8* jb_flag);

/* 
 * :  UnpackSavedataJson
 * :     豸Ƶ豸EDPЭ, 洢(jsonʽ)
 * ˵:    صjson(json_obj)Ҫͻͷ
 * غ:PacketSavedataJson, GetEdpPacket, EdpPacketType, UnpackSavedata
 * :    pkg         EDP, savedatajsonݰ
 *          json_obj    json 
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
int32 UnpackSavedataJson(EdpPacket* pkg, cJSON** json_obj);

/* 
 * :  UnpackSavedataBin
 * :     豸Ƶ豸EDPЭ, 洢(binʽ)
 * ˵:    ص(desc_obj)bin(bin_data)Ҫͻͷ
 * غ:PacketSavedataBin, GetEdpPacket, EdpPacketType, UnpackSavedata
 * :    pkg         EDP, savedatabinݰ
 *          desc_obj     jsonʽ
 *          bin_data    
 *          bin_len     ݳ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
int32 UnpackSavedataBin(EdpPacket* pkg, cJSON** desc_obj, 
        uint8** bin_data, uint32* bin_len);
/* 
 * :  UnpackSavedataBinStr
 * :     豸Ƶ豸EDPЭ, 洢(binʽ)
 * ˵:    ص(desc_obj)bin(bin_data)Ҫͻͷ
 * غ:PacketSavedataBin, GetEdpPacket, EdpPacketType, UnpackSavedata
 * :    pkg         EDP, savedatabinݰ
 *          desc_obj     stringʽ
 *          bin_data    
 *          bin_len     ݳ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackSavedataBinStr(EdpPacket* pkg, char** desc_str, 
        uint8** bin_data, uint32* bin_len);
/* 
 * :  PacketCmdResp
 * :    Ӧ
 * ˵:    صEDP͸豸ƺ, Ҫͻɾð
 *          
 * غ:UnpackCmdReq
 * :    cmdid       id
 *          cmdid_len   id
 *          resp        ӦϢ
 *          resp_len    ӦϢ
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketCmdResp(const char* cmdid, uint16 cmdid_len, 
        const char* resp, uint32 resp_len);

/* 
 * :  UnpackCmdReq
 * :     豸Ƶ豸EDPЭ, Ϣ
 * ˵:    豸Ʒ, Ϣ
 *          ȡcmdidԼreqҪʹúͷš
 * غ:PacketCmdResp
 * :    pkg         EDP
 *          cmdid       ȡid
 *          cmdid_len   cmdidĳ
 *          req         ûʼλ
 *          req_len     ûĳ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackCmdReq(EdpPacket* pkg, char** cmdid, uint16* cmdid_len, 
			      char** req, uint32* req_len);

/* 
 * :  PacketPing
 * :     豸豸ƵEDPЭ, 
 * ˵:    صEDP͸豸ƺ, Ҫͻɾð
 *          豸ƻظӦ豸
 * غ:UnpackPingResp
 * :    
 * ֵ:   (EdpPacket*) 
 *          ǿ        EDPЭ
 *          Ϊ        EDPЭʧ 
 */
EDPKIT_DLL EdpPacket* PacketPing(void);

/* 
 * :  UnpackPingResp
 * :     豸Ƶ豸EDPЭ, Ӧ
 * ˵:    豸Ʒ, ͨGetEdpPacketEdpPacketTypeжϳӦ, 
 *          ӦEDPΪ, ɸúн
 * غ:PacketPing, GetEdpPacket, EdpPacketType
 * :    pkg         EDP, Ӧ
 * ֵ:   (int32) 
 *          =0          ɹ
 *          >0          ʧ, ʧԭ<OneNet뷽ӿ.docx>
 *          <0          ʧ, ʧԭhļĴ
 */
EDPKIT_DLL int32 UnpackPingResp(EdpPacket* pkg);

#ifdef __cplusplus
}
#endif

#endif /* __EDP_KIT_H__ */
